#!/opt/misc/bin/perl
                                  $hkgroups::version = "hks v1.005  7 Apr 00";
#-----------------------------------------------------------------------------
#
#                      GGGGG
#    H    H   K    K  G     G   RRRRR     OOOO    U    U   PPPPP     SSSS
#    H    H   K   K   G         R    R   O    O   U    U   P    P   S
#    HHHHHH   KKKK    G  GGGG   R    R   O    O   U    U   P    P    SSSS
#    H    H   K  K    G     G   RRRRR    O    O   U    U   PPPPP         S
#    H    H   K   K   G     G   R   R    O    O   U    U   P        S    S
#    H    H   K    K   GGGGG    R    R    OOOO     UUUU    P         SSSS
#
#-----------------------------------------------------------------------------
# 1.003 28 Mar 00 dbb Since v16819 & v16817 are currently installed in G/C,
#                     hks must be sure to upload to upper only after a
#                     partial version has move the rx/tx buffers.
#                     This hks does some smart uploading...
# 1.005  7 Apr 00 dbb Added HV tests, Reset Tests, Verbose switch
#-----------------------------------------------------------------------------

#-----------------------------------------------------------------------------
# The 'use strict' directive forces the coder to follow rules that might keep
# him out of trouble by calling attention to undeclared variables and the like.
use strict;

# my $timeout;

#-----------------------------------------------------------------------------
sub checkresult {
  my $readback = shift(@_);
  my $pmask  = shift(@_);
  my $expectedresult = shift(@_);
  my $result;

  system("noop");    # force hkp update
  if (defined $main::Slow) { system("sleep 1"); } # once-per-second behavior requested
  %main::hkpitems = split(" ",`hkprint 0x1440-183E`); # take a snapshot hkp memory
  %main::memitems = split(" ",`hkprint 0x1040-183E`); # take a snapshot of hkp memory
  my $controls = hex($main::hkpitems{$readback}); # get C1 and C2

  if ($expectedresult == ($controls & $pmask)) { 
    $result = 0;
  } # if
  else {
    $result = 1; # not the expected result
  } # else
  return $result; 
} # checkresult

#-----------------------------------------------------------------------------
sub cmdtest10 {
  my $cmdname = shift(@_);
  my $readback = shift(@_);
  my $pmask  = shift(@_);
  my $expectedresult = shift(@_);
  my $timeout;
  print "Testing $cmdname by reading back from $readback";
  printf " mask %04X, expecting %04X :", $pmask, $expectedresult;
  $main::TestCounter++;

  if (checkresult($readback,$pmask,$expectedresult)) {
    system($cmdname);  # send the trial command
    if (defined $main::Slow) { system("sleep 1"); } # once-per-second behavior requested
    $timeout = $main::stdtimeout; # best guess
    my $stilltesting = 1; # set this flag
    while ($timeout && $stilltesting) {
      $timeout--;
      if ($timeout == ($main::Slow?2:12)) { system("noop"); } # elicit a response if necessary
      $stilltesting = checkresult($readback, $pmask, $expectedresult);
    } # we wait for expected result to appear in housekeeping
    if (!$timeout) {
      print "*Fail*";
      $main::Failures++;
    } else { print "Pass"; }
  } # if the bits are in the right state for testing.
  else {
    printf "Inconclusive"; # Wrong state for testing!
    $main::Inconclusives++;
    $timeout = 99; # we're calling it a non-failure, and reporting it that way
  }
  print "\n";
  return $timeout; # pass is non-zero
} # sub cmdtest10

#-----------------------------------------------------------------------------
sub testresult {
  my $readback = shift(@_);
  my $pmask  = shift(@_);
  my $expectedresult = shift(@_);

  my $controls = hex($main::memitems{$readback}); # get C1 and C2
  return ($expectedresult != ($controls & $pmask)); # zero when matching
} # testresult

#-----------------------------------------------------------------------------
sub cmdtest11 {
  my $opcode = shift(@_);
  my $param0 = shift(@_);
  my $readback = shift(@_);
  my $pmask  = shift(@_);
  my $expectedresult = shift(@_);
  my $tmpcode = $opcode & 255; # lop-off upper byte

# print "Opcode:$opcode\n";
  $opcode = $tmpcode + (256 * $tmpcode); # high byte is a duplicate of lower byte
  # $opcode = sprintf "%04x", $tmpcode + (256 * $tmpcode); # high byte is a duplicate of lower byte
# print "Opcode:$opcode\n";
# return;

  printf "Testing %04x $param0 by reading back from $readback", $opcode ;
  printf " mask %04X, expecting %04X :", $pmask, $expectedresult;
  # printf "$readback=0x%04X:\n", hex($main::memitems{$readback});

  $main::TestCounter++;

  my $timeout = testresult($readback, $pmask, $expectedresult); # true when different
  if ($timeout) {
    $timeout = sendcommand($opcode, $param0, 0, 0);
    if ($timeout) {
      $timeout = testresult($readback, $pmask, $expectedresult); # true when different
      printf "0x%04X:", hex($main::memitems{$readback});
      if ($timeout) {
        print "*Fail*";
        $main::Failures++;
      } else { 
        print "Pass";
      }
    } else {
      print "*Timeout*";
      $main::Failures++;
    } # no response is a failure.
  } # if the bits are in the right state for testing.
  else {
    printf "0x%04X:", hex($main::memitems{$readback});
    print "Inconclusive"; # Wrong state for testing!
    $main::Inconclusives++;
    $timeout = 99; # we're calling it a non-failure, and reporting it that way
  }
  print "\n";
  return $timeout; # pass is non-zero
} # sub cmdtest11

